
/*
xpvox copyright (c) 2005 Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "forms.h"
#include "xpvox.h"

extern FD_xpvox *fdui;


char *strsave(char *s) /* save char array s somewhere */
{
char *p;

p = malloc( strlen(s) +  1);
if(! p) return 0;

strcpy(p, s);
return p;
} /* end function strsave */


void use_xpequ_button_cb(FL_OBJECT *ob, long data)
{
use_xpequ_flag = fl_get_button(ob);

save_audio_settings();

} /* end function use_xpequ_button_cb */


void agc_button_cb(FL_OBJECT *ob, long data)
{
agc_flag = fl_get_button(ob);
if(agc_flag)
	{       
	agc_init_flag = 0;
        
	agc_multiplier = 1.0;
	}            

save_audio_settings();

} /* end function agc_button_cb */


void off_time_x10_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "off_time_x10_button_cb(): arg none\n"); 
	}

off_time_10x_flag = fl_get_button(ob);

set_off_slider_bounds();

save_audio_settings();

} /* end function off_time_x10_button_cb */


void log_button_cb(FL_OBJECT *ob, long data)
{
char *ptr;

if(debug_flag)
	{
	fprintf(stderr,\
	"log_button_cb(): arg none, using log_flag=%d log_filename=%s\n",\
	log_flag, log_filename);
	}

log_flag = fl_get_button(ob);

if(log_flag)
	{
	ptr = (char *)fl_show_fselector("SELECT LOG FILE", home_dir, "*.log", log_filename);
	if(ptr)
		{
		if(log_filename) free(log_filename);
		log_filename = strsave(ptr);
		if(! log_filename)
			{
			fprintf(stderr, "log_button_cb(): could not allocate space for log_filename %s.\n", ptr);


			return;
			}
		}
	else
		{
		fl_set_button(ob, 0);
		log_flag = 0;
		}
	} /* end if log_flag */

save_setting("log_filename", log_filename);

save_audio_settings();

} /* end function log_button_cb */


void show_sounds_without_path_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "show_sounds_without_path_button_cb(): arg none\n");
	}

show_sounds_without_path_flag = fl_get_button(ob);

show_sounds(SHOW_SELECTED);

save_audio_settings();

} /* end function show_sounds_without_path_button_cb */


void transmit_button_cb(FL_OBJECT *ob, long data)
{
} /* end function transmit_button_cb */


void beacon_sound_button_cb(FL_OBJECT *ob, long data)
{
beacon_flag = fl_get_button(ob);

} /* end function beacon_sound_button_cb */


void beacon_period_time_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob); 
if(! ptr) return;

beacon_period_time = atoi(ptr);

save_audio_settings();

} /* end function beacon_period_time_input_field_cb */


void timed_play_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

auto_transmit_flag = fl_get_button(ob);

if(auto_transmit_flag)
	{
	}
else
	{
	stop_player();

	auto_play_sequence_flag = 0;  
	}

fl_set_object_color(ob, FL_COL1, FL_DARKORANGE);

sprintf(temp, "%d", auto_play_sequence_number);
fl_set_input(fdui -> play_one_per_day_next_input_field, temp);

save_audio_settings();

} /* end function timed_play_button_cb */


void timed_play_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;
int a;
char temp[80];
time_t now;
struct tm *broken_time;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

a = sscanf(ptr, "%2d:%2d", &alarm_hour, &alarm_minute);

if(a != 2)
	{
	now = time(0);
	broken_time = localtime (&now);

	sprintf(temp, "%02d:%02d", broken_time -> tm_hour, broken_time -> tm_min);
	fl_show_alert("Start time, format is 24 hour clock\nhh:mm", "For example:",temp, 0);

	return;
	}

save_audio_settings();

} /* end function timed_play_input_field_cb */


void play_one_per_day_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(debug_flag)
	{
	fprintf(stderr, "play_one_per_day_button(): arg none\n");
	}

play_one_per_day_flag = fl_get_button(ob);

if(! play_one_per_day_flag)
	{
	auto_play_sequence_number = 1;
	}

sprintf(temp, "%d", auto_play_sequence_number);
fl_set_input(fdui -> play_one_per_day_next_input_field, temp);

save_audio_settings();

} /* end function play_one_per_day_button_cb */


void play_one_per_day_next_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

if(debug_flag)
	{
	fprintf(stderr, "play_one_per_day_next_input_field_cb(): arg none\n");
	}

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

auto_play_sequence_number = atoi(ptr);

save_audio_settings();

} /* end function play_one_per_day_next_input_field_cb */


void threshold_slider_cb(FL_OBJECT *ob, long data)
{
char temp[1024];

threshold = fl_get_slider_value(ob);

sprintf(temp, "%.2f ", threshold);
save_setting("threshold", temp);

} /* end function threshold_slider_cb */


void audio_peak_indicator_slider_cb(FL_OBJECT *ob, long data)
{
/* set from idle_cb() */
} /* end function audio_peak_indicator_slider_cb */


void on_time_slider_cb(FL_OBJECT *ob, long data)
{
char temp[1024];

on_milli_seconds = fl_get_slider_value(ob);

if(debug_flag)
	{
	fprintf(stderr, "on_milli_seconds=%.2f\n", on_milli_seconds);
	}

//(int)high_samples = (double) on_milli_seconds / (double) milli_seconds_per_sample;
high_samples = on_milli_seconds / milli_seconds_per_sample;

sprintf(temp, "%.2f ", on_milli_seconds);
save_setting("on_milli_seconds", temp);

} /* end function threshold_slider_cb */


void off_time_slider_cb(FL_OBJECT *ob, long data)
{
char temp[1024];

off_milli_seconds = fl_get_slider_value(ob);

if(debug_flag)
	{
	fprintf(stderr, "off_milli_seconds=%.2f\n", off_milli_seconds);
	}

//(int)low_samples = (double) off_milli_seconds / (double) milli_seconds_per_sample;
low_samples = off_milli_seconds / milli_seconds_per_sample;

sprintf(temp, "%.2f ", off_milli_seconds);
save_setting("off_milli_seconds", temp);

} /* end function threshold_slider_cb */


void transmission_inhibit_button_cb(FL_OBJECT *ob, long data)
{
transmission_inhibit_flag = fl_get_button(ob);

/*
stop or restore any transmission
Trick is: when transmission_inhibit_flag this sets RTS to zero always! (see set_rts() in serial .c).
*/
set_rts(serial_device, rts_requested_on_flag);

} /* end function transmission_inhibit_button_cb */


void transmission_lock_button_cb(FL_OBJECT *ob, long data)
{
transmission_lock_flag = fl_get_button(ob);

if(transmission_lock_flag)
	{
	fl_set_button(fdui -> transmit_button, 1);
	}
else
	{
	fl_set_button(fdui -> transmit_button, 0);
	}
} /* end function transmission_lock_button_cb */


void sound_browser_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;
char temp[80];

if(debug_flag)
	{
	fprintf(stderr, "sound_browser_cb(): arg none\n");
	}

mouse_button = fl_mouse_button();

selected_line = fl_get_browser(ob);
if(! selected_line) return;

selected_sound = abs(selected_line);
fl_select_browser_line(ob, selected_line);

if(mouse_button == FL_LEFT_MOUSE)
	{
	sprintf(temp, "%d ", selected_sound);
	save_setting("selected_sound", temp);

	return;
	}
else if(mouse_button == FL_MIDDLE_MOUSE)
	{
	set_sound(selected_sound, LEAD_IN);
	
	sprintf(temp, "%d ", selected_sound);
	save_setting("selected_sound", temp);

	return;
	}
else if(mouse_button == FL_RIGHT_MOUSE)
	{
	set_sound(selected_sound, LEAD_OUT);

	sprintf(temp, "%d ", selected_sound);
	save_setting("selected_sound", temp);

	return;
	}

} /* end function sound_browser_cb */


void sound_browser_double_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;
char temp[80];
int next_in_play_sequence = 0;
char *ptr;

if(debug_flag)
	{
	fprintf(stderr, "sound_browser_double_cb(): arg none\n");
	}

mouse_button = fl_mouse_button();

selected_line = fl_get_browser(ob);
if(! selected_line) return;

selected_sound = abs(selected_line);
fl_select_browser_line(ob, selected_line);

if(mouse_button == FL_LEFT_MOUSE)
	{
	if(! get_next_in_play_sequence(&next_in_play_sequence) ) return;

	sprintf(temp, "%d", next_in_play_sequence);
	ptr = (char *) fl_show_input("Enter play sequence number, use 0 to remove.", temp);
	if(! ptr) return;

	if(! add_play_sequence_number(selected_sound, atoi(ptr) ) ) return;

	show_sounds(SHOW_SAME_POSITION);

	save_sounds();

	return;
	}
else if(mouse_button == FL_MIDDLE_MOUSE)
	{
	return;
	}
else if(mouse_button == FL_RIGHT_MOUSE)
	{

	return;
	}

} /* end function sound_browser_double_cb */


void add_sound_button_cb(FL_OBJECT *ob, long data)
{
int a;
char *ptr, *ptr2;

ptr = (char *)fl_show_fselector("SELECT A SOUND WAVE FILE", sound_dir, "*.[wm][ap][av23]", "");
if(! ptr) return;

if(! add_sound(ptr) )
	{
	fl_show_alert("could not add sound file ", ptr, "", 0);

	return;
	}

/* extract sound_dir */
// /root/greetings4.wav

ptr2 = strrchr(ptr, '/');
if(! ptr2)
	{
	fprintf(stderr, "add_sound_button_cb(): could not extract sound_dir\n");
	return;
	}
a = ptr2 - ptr;
if(a == 0)
	{
	fprintf(stderr, "add_sound_button_cb(): could not extract sound_dir, a=0\n");
	return;
	}

free(sound_dir);
sound_dir = (char *)malloc(a + 1);
strncpy(sound_dir, ptr, a);
sound_dir[a] = 0;

if(debug_flag)
	{
	fprintf(stderr, "add_sound_button_cb(): a=%d extracted sound_dir=%p (%s)\n", a, sound_dir, sound_dir);
	}

save_setting("sound_dir", sound_dir);

} /* end function add_sound_button_cb */


void delete_sound_button_cb(FL_OBJECT *ob, long data)
{
struct sound *pa;
char temp[4096];

if(debug_flag)
	{
	fprintf(stderr, "delete_sound_button_cb(): arg none\n");
	}

if(selected_sound < 0) return;

/* find the entry in the linked list */
for(pa = soundtab[0]; pa != 0; pa = pa -> nxtentr)	
	{
	if(pa -> browser_line == selected_sound)
		{
		sprintf(temp, "Remove %s from list?", pa -> name);
		if(! fl_show_question(temp, 0) ) return; /* mouse on NO */

		if(! delete_sound(pa -> name) )
			{
			fl_show_alert("could not delete sound file ", pa -> name, "", 0);
			}

		sort_sounds();

		save_sounds();

		show_sounds(SHOW_SAME_POSITION);

		return;
		}
	} /* end for all entries in list */

/* not found */
return;
} /* end function delete_sound_button_cb */


void play_sound_button_cb(FL_OBJECT *ob, long data)
{

if(debug_flag)
	{
	fprintf(stderr, "play_sound_button_cb(): arg none\n");
	}

if(selected_sound < 0) return;

start_player(SELECTED_SOUND);

return;
} /* end function play_sound_button_cb */


void stop_sound_button_cb(FL_OBJECT *ob, long data)
{

if(debug_flag)
	{
	fprintf(stderr, "stop_sound_button_cb(): arg none\n");
	}

if(selected_sound < 0) return;

stop_player();

return;
} /* end function stop_sound_button_cb */


void in_sound_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "in_sound_button_cb(): arg none\n");
	}

play_lead_in_flag = fl_get_button(ob);

save_audio_settings();

return;
} /* end function in_sound_button_cb */


void out_sound_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "out_sound_button_cb(): arg none\n");
	}

play_lead_out_flag = fl_get_button(ob);

save_audio_settings();

return;
} /* end function out_sound_button_cb */


void audio_input_device_select_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "audio_input_device_select_button_cb(): arg none\n");
	}

if( fl_get_button(fdui -> transmit_button) )
	{
	fl_show_alert(\
	"transmission in progress",\
	"STOP transmitting first",\
	"command cancelled.", 0);

	return;
	}

audio_input_device_number++;
if(audio_input_device_number > AUDIO_DEVICE_LAST) audio_input_device_number = AUDIO_DEVICE_FIRST;

stop_audio();
set_audio_input_device(audio_input_device_number);
start_audio();

save_audio_settings();

return;
} /* end function audio_input_device_select_button_cb */


void audio_output_device_select_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "audio_output_device_select_button_cb(): arg none\n");
	}

if(playing_flag)
	{
	fl_show_alert(\
	"playing in progress",\
	"please use STOP button first",\
	"command cancelled.", 0);

	return;
	}

audio_output_device_number++;
if(audio_output_device_number > AUDIO_DEVICE_LAST) audio_output_device_number = AUDIO_DEVICE_FIRST;

set_audio_output_device(audio_output_device_number);

save_audio_settings();

return;
} /* end function audio_output_device_select_button_cb */


void exit_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(debug_flag)
	{
	fprintf(stderr, "exit_button_cb(): arg none\n");
	}
	
stop_player();

save_setting("sound_dir", sound_dir);

sprintf(temp, "%.2f ", threshold);
save_setting("threshold", temp);

sprintf(temp, "%.2f ", on_milli_seconds);
save_setting("on_milli_seconds", temp);

sprintf(temp, "%.2f ", off_milli_seconds);
save_setting("off_milli_seconds", temp);

sprintf(temp, "%d ", selected_sound);
save_setting("selected_sound", temp);

save_setting("log_filename", log_filename);

save_audio_settings();

exit(0);
} /* end function exit_button_cb */


/* signal handler */
void one_second_tick(int sig)
{
time_t now;
struct tm *broken_time;
char temp[80];
char *ptr;
int a;
int current_seconds, alarm_seconds, remaining_seconds, r_hours, r_minutes, r_seconds;
static int seconds_in_transmission;
int t_hours, t_minutes, t_seconds;

now = time(0); //  + 3600 * offset;
broken_time = localtime (&now);

sprintf(temp,\
"AUTO\n%02d:%02d.%02d",\
broken_time -> tm_hour, broken_time -> tm_min, broken_time -> tm_sec);
fl_set_object_label(fdui -> timed_play_button, temp);

ptr = (char *) fl_get_input(fdui -> timed_play_input_field);
if(ptr)
	{
	a = sscanf(ptr, "%2d:%2d", &alarm_hour, &alarm_minute);

//	fprintf(stderr, "one_second_tick(): alarm_hour=%d alarm_minute=%d\n", alarm_hour, alarm_minute);
	}

ogettime(weekday, month, &monthday, &hour, &minute, &second, &year);

//#define TIMER_TEST
#ifdef TIMER_TEST
if(second == 0)
#else
if( (hour == alarm_hour) && (minute == alarm_minute) && (second == 0) )
#endif
	{
	if(debug_flag)
		{
		fprintf(stderr, "time_match\n");
		}

	time_match_flag = 1;
	}
else
	{
	time_match_flag = 0;
	}

alarm_seconds = (3600 * alarm_hour ) + (60 * alarm_minute); 
current_seconds = (3600 * hour) + (60 * minute) + second;
remaining_seconds = alarm_seconds - current_seconds;
if(remaining_seconds < 0) remaining_seconds += 24 * 3600;
r_hours = remaining_seconds / 3600;
r_minutes = (remaining_seconds - (3600 * r_hours) ) / 60;
r_seconds = remaining_seconds - (3600 * r_hours) - (60 * r_minutes);

if(debug_flag)
	{
	fprintf(stderr,\
	"alarm_seconds=%d current_seconds=%d remaining_seconds=%d r_hours=%d r_minutes=%d r_seconds=%d\n",\
	alarm_seconds, current_seconds, remaining_seconds,\
	r_hours, r_minutes, r_seconds);
	}

if(! rts_is_on_flag)
	{
	seconds_in_transmission = 0;
	}
else
	{
	seconds_in_transmission++;
	}

if(rts_is_on_flag)
	{
	t_hours = seconds_in_transmission / 3600;
	t_minutes = (seconds_in_transmission - (3600 * t_hours) ) / 60;
	t_seconds = seconds_in_transmission - (3600 * t_hours) - (60 * t_minutes);

	sprintf(temp, "Time\nin transmission\n%02d:%02d:%02d", t_hours, t_minutes, t_seconds);
	fl_set_object_label(fdui -> transmit_button, temp);
	}
else if(auto_transmit_flag)
	{
	sprintf(temp, "Time to next\ntransmission\n%02d:%02d:%02d", r_hours, r_minutes, r_seconds);
	fl_set_object_label(fdui -> transmit_button, temp);

	/* transmision in 5 minute alarm during 10 seconds */
	if( (remaining_seconds <= 300) && (remaining_seconds >= 290) )
		{
		fl_ringbell(0);
		}
	}
else
	{
	fl_set_object_label(fdui -> transmit_button, "TRANSMIT");
	}

if(auto_transmit_flag && time_match_flag)
	{
	auto_play_sequence_flag = 1;
	}

fl_add_signal_callback(SIGALRM, (FL_SIGNAL_HANDLER)one_second_tick, NULL); //&mydata);

/* reenable the timer */
alarm(1);
} /* end function one_second_tick (signal handler) */


